/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package forms;

import dao.ClienteDao;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import model.Cliente;

/**
 *
 * @author pedroh
 */
public class FormBuscaCliente extends javax.swing.JFrame {
    
    DefaultTableModel modelo;

    /**
     * Creates new form FormBuscaCliente
     */
    public FormBuscaCliente() {
        initComponents();
        modelo = (DefaultTableModel) jtCliente.getModel();
        btExcluir.setEnabled(false);
        btEditar.setEnabled(false);
        btAgendar.setEnabled(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        tfNome = new javax.swing.JTextField();
        btBuscar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jtCliente = new javax.swing.JTable();
        btEditar = new javax.swing.JButton();
        btExcluir = new javax.swing.JButton();
        cbTodos = new javax.swing.JCheckBox();
        btCancelar = new javax.swing.JButton();
        btAgendar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Busca de Cliente");
        setResizable(false);

        jLabel1.setText("Nome:");

        btBuscar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/system-search-3.png"))); // NOI18N
        btBuscar.setText("Buscar");
        btBuscar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btBuscarActionPerformed(evt);
            }
        });

        jtCliente.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "CPF", "Nome", "Sexo", "Telefone"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jtCliente.getTableHeader().setReorderingAllowed(false);
        jScrollPane1.setViewportView(jtCliente);
        if (jtCliente.getColumnModel().getColumnCount() > 0) {
            jtCliente.getColumnModel().getColumn(0).setResizable(false);
            jtCliente.getColumnModel().getColumn(1).setResizable(false);
            jtCliente.getColumnModel().getColumn(1).setPreferredWidth(200);
            jtCliente.getColumnModel().getColumn(2).setResizable(false);
            jtCliente.getColumnModel().getColumn(2).setPreferredWidth(10);
            jtCliente.getColumnModel().getColumn(3).setResizable(false);
        }

        btEditar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/edit-4.png"))); // NOI18N
        btEditar.setText("Editar");
        btEditar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btEditarActionPerformed(evt);
            }
        });

        btExcluir.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/edit-delete-2.png"))); // NOI18N
        btExcluir.setText("Excluir");
        btExcluir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btExcluirActionPerformed(evt);
            }
        });

        cbTodos.setText("Todos");

        btCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/dialog-cancel-3.png"))); // NOI18N
        btCancelar.setText("Cancelar");
        btCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btCancelarActionPerformed(evt);
            }
        });

        btAgendar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/address-book-new-3.png"))); // NOI18N
        btAgendar.setText("Agendar Atendimento");
        btAgendar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btAgendarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(tfNome, javax.swing.GroupLayout.PREFERRED_SIZE, 262, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(btBuscar)
                        .addGap(18, 18, 18)
                        .addComponent(cbTodos)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addGap(48, 48, 48)
                .addComponent(btEditar)
                .addGap(18, 18, 18)
                .addComponent(btExcluir)
                .addGap(18, 18, 18)
                .addComponent(btCancelar)
                .addGap(18, 18, 18)
                .addComponent(btAgendar)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(tfNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btBuscar)
                    .addComponent(cbTodos))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btCancelar, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(btEditar)
                        .addComponent(btExcluir)
                        .addComponent(btAgendar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void btBuscarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btBuscarActionPerformed
        limparGUI();
        
        
        if(tfNome.getText().equals("") && !cbTodos.isSelected()){
            JOptionPane.showMessageDialog(null, "Campo 'Nome' está vazio!","Nenhum nome",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        ArrayList<Cliente> clientes;
        try {
            if(cbTodos.isSelected())
                clientes = (ArrayList<Cliente>) (new ClienteDao()).todosClientes();
            else
                clientes = (ArrayList<Cliente>) (new ClienteDao()).buscarClienteNome(tfNome.getText());
        } catch (NullPointerException e) {
            JOptionPane.showMessageDialog(null,"Não foi possível se conectar a base de dados","Erro busca",JOptionPane.ERROR_MESSAGE);
            return;
        }catch (Exception e) {
            JOptionPane.showMessageDialog(null,e,"Erro busca",JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        if(clientes.isEmpty()){
            JOptionPane.showMessageDialog(null, "Nenhum cliente com este nome foi encontrado","Nome não encontrado",JOptionPane.INFORMATION_MESSAGE);
            return;
        }
        
        for(Cliente c : clientes){
            modelo.addRow(new Object[]{
                c.getCpf(),
                c.getNome(),
                c.getSexo(),
                c.getTelefone()
            });
        }
        
        btEditar.setEnabled(true);
        btExcluir.setEnabled(true);
        btAgendar.setEnabled(true);
    }//GEN-LAST:event_btBuscarActionPerformed

    private void btExcluirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btExcluirActionPerformed
        int linhaSelecionada = jtCliente.getSelectedRow();
        if(linhaSelecionada == -1){
            JOptionPane.showMessageDialog(null, "Nenhum cliente selecionado!");
            return;
        }
        
        int j = JOptionPane.showConfirmDialog(null, "Tem certeza que deseja excluir este cliente?","Remover Cliente", JOptionPane.YES_NO_OPTION);
        if(!(j == JOptionPane.YES_OPTION))
            return;
        
        try{
            Cliente cliente = (new ClienteDao()).procurarClienteCpf((String)modelo.getValueAt(linhaSelecionada, 0));
            (new ClienteDao()).excluir(cliente);
        }catch(Exception e){
            JOptionPane.showMessageDialog(null, e,"ERRO",JOptionPane.ERROR_MESSAGE);
            return;
        }
        this.btBuscarActionPerformed(evt);
        JOptionPane.showMessageDialog(null, "Cliente removido com sucesso","removido com sucesso",JOptionPane.INFORMATION_MESSAGE);
        
        limparGUI();
    }//GEN-LAST:event_btExcluirActionPerformed

    private void btEditarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btEditarActionPerformed
        int linhaSelecionada = jtCliente.getSelectedRow();
        if(linhaSelecionada == -1){
            JOptionPane.showMessageDialog(null, "Nenhum cliente selecionado!");
            return;
        }
        
        try{
            ClienteDao cdao = new ClienteDao();
            Cliente cliente = cdao.procurarClienteCpf((String) modelo.getValueAt(linhaSelecionada, 0));
            (new FormCliente(cliente)).setVisible(true);
        }catch(Exception e){
            JOptionPane.showMessageDialog(null, e,"Erro",JOptionPane.ERROR_MESSAGE);
        }
        
        limparGUI();
    }//GEN-LAST:event_btEditarActionPerformed

    private void btCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btCancelarActionPerformed
        this.dispose();
    }//GEN-LAST:event_btCancelarActionPerformed

    private void btAgendarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btAgendarActionPerformed
       int linhaSelecionada = jtCliente.getSelectedRow();
        if(linhaSelecionada == -1){
            JOptionPane.showMessageDialog(null, "Nenhum cliente selecionado!");
            return;
        }
        
        try{
            ClienteDao cdao = new ClienteDao();
            Cliente cliente = cdao.procurarClienteCpf((String) modelo.getValueAt(linhaSelecionada, 0));
            (new FormAgendamento(cliente)).setVisible(true);
        }catch(Exception e){
            JOptionPane.showMessageDialog(null, e,"Erro",JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_btAgendarActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FormBuscaCliente.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FormBuscaCliente.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FormBuscaCliente.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FormBuscaCliente.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FormBuscaCliente().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btAgendar;
    private javax.swing.JButton btBuscar;
    private javax.swing.JButton btCancelar;
    private javax.swing.JButton btEditar;
    private javax.swing.JButton btExcluir;
    private javax.swing.JCheckBox cbTodos;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jtCliente;
    private javax.swing.JTextField tfNome;
    // End of variables declaration//GEN-END:variables

    private void limparGUI(){
        for(int i = modelo.getRowCount()-1; i>=0;i--)
            modelo.removeRow(i);
        
        btEditar.setEnabled(false);
        btExcluir.setEnabled(false);
        btAgendar.setEnabled(false);
    }
    
    
}
